/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreStudy.TCoreStudyPath;
import de.ship.db.tables.TDmTablegrpdetail.TDmTablegrpdetailPath;
import de.ship.db.tables.records.TDmTablegrpRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TDmTablegrp extends TableImpl<TDmTablegrpRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_dm_tablegrp</code>
     */
    public static final TDmTablegrp T_DM_TABLEGRP = new TDmTablegrp();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TDmTablegrpRecord> getRecordType() {
        return TDmTablegrpRecord.class;
    }

    /**
     * The column <code>common_dd.t_dm_tablegrp.lastchange</code>.
     */
    public final TableField<TDmTablegrpRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_dm_tablegrp.pk</code>. ID of
     * examination/table group
     */
    public final TableField<TDmTablegrpRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "ID of examination/table group");

    /**
     * The column <code>common_dd.t_dm_tablegrp.fk_study_id</code>. foreign key
     * to ID of study
     */
    public final TableField<TDmTablegrpRecord, Integer> FK_STUDY_ID = createField(DSL.name("fk_study_id"), SQLDataType.INTEGER.nullable(false), this, "foreign key to ID of study");

    /**
     * The column <code>common_dd.t_dm_tablegrp.table_grp</code>. name of
     * examination/table group
     */
    public final TableField<TDmTablegrpRecord, String> TABLE_GRP = createField(DSL.name("table_grp"), SQLDataType.CLOB.nullable(false), this, "name of examination/table group");

    /**
     * The column <code>common_dd.t_dm_tablegrp.table_grp_order</code>. order of
     * examination/table group
     */
    public final TableField<TDmTablegrpRecord, Integer> TABLE_GRP_ORDER = createField(DSL.name("table_grp_order"), SQLDataType.INTEGER, this, "order of examination/table group");

    private TDmTablegrp(Name alias, Table<TDmTablegrpRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TDmTablegrp(Name alias, Table<TDmTablegrpRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_tablegrp</code> table reference
     */
    public TDmTablegrp(String alias) {
        this(DSL.name(alias), T_DM_TABLEGRP);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_tablegrp</code> table reference
     */
    public TDmTablegrp(Name alias) {
        this(alias, T_DM_TABLEGRP);
    }

    /**
     * Create a <code>common_dd.t_dm_tablegrp</code> table reference
     */
    public TDmTablegrp() {
        this(DSL.name("t_dm_tablegrp"), null);
    }

    public <O extends Record> TDmTablegrp(Table<O> path, ForeignKey<O, TDmTablegrpRecord> childPath, InverseForeignKey<O, TDmTablegrpRecord> parentPath) {
        super(path, childPath, parentPath, T_DM_TABLEGRP);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TDmTablegrpPath extends TDmTablegrp implements Path<TDmTablegrpRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TDmTablegrpPath(Table<O> path, ForeignKey<O, TDmTablegrpRecord> childPath, InverseForeignKey<O, TDmTablegrpRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TDmTablegrpPath(Name alias, Table<TDmTablegrpRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TDmTablegrpPath as(String alias) {
            return new TDmTablegrpPath(DSL.name(alias), this);
        }

        @Override
        public TDmTablegrpPath as(Name alias) {
            return new TDmTablegrpPath(alias, this);
        }

        @Override
        public TDmTablegrpPath as(Table<?> alias) {
            return new TDmTablegrpPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TDmTablegrpRecord, Integer> getIdentity() {
        return (Identity<TDmTablegrpRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TDmTablegrpRecord> getPrimaryKey() {
        return Keys.PK_DM_TABLEGRP;
    }

    @Override
    public List<ForeignKey<TDmTablegrpRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_DM_TABLEGRP__FK_STUDY_ID);
    }

    private transient TCoreStudyPath _tCoreStudy;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_study</code>
     * table.
     */
    public TCoreStudyPath tCoreStudy() {
        if (_tCoreStudy == null)
            _tCoreStudy = new TCoreStudyPath(this, Keys.T_DM_TABLEGRP__FK_STUDY_ID, null);

        return _tCoreStudy;
    }

    private transient TDmTablegrpdetailPath _tDmTablegrpdetail;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_tablegrpdetail</code> table
     */
    public TDmTablegrpdetailPath tDmTablegrpdetail() {
        if (_tDmTablegrpdetail == null)
            _tDmTablegrpdetail = new TDmTablegrpdetailPath(this, null, Keys.T_DM_TABLEGRPDETAIL__FK_TABLEGRPDETAIL_TABLEGRP.getInverseKey());

        return _tDmTablegrpdetail;
    }

    @Override
    public TDmTablegrp as(String alias) {
        return new TDmTablegrp(DSL.name(alias), this);
    }

    @Override
    public TDmTablegrp as(Name alias) {
        return new TDmTablegrp(alias, this);
    }

    @Override
    public TDmTablegrp as(Table<?> alias) {
        return new TDmTablegrp(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTablegrp rename(String name) {
        return new TDmTablegrp(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTablegrp rename(Name name) {
        return new TDmTablegrp(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTablegrp rename(Table<?> name) {
        return new TDmTablegrp(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablegrp where(Condition condition) {
        return new TDmTablegrp(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablegrp where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablegrp where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablegrp where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTablegrp where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTablegrp where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTablegrp where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTablegrp where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablegrp whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablegrp whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
